Index: django/template/defaultfilters.py
===================================================================
--- django/template/defaultfilters.py	(Revision 15148)
+++ django/template/defaultfilters.py	(Arbeitskopie)
@@ -799,19 +799,21 @@
     try:
         bytes = float(bytes)
     except (TypeError,ValueError,UnicodeDecodeError):
-        return u"0 bytes"
+        return ungettext("%(size)d byte", "%(size)d bytes", 0) % {'size': 0}
 
+    filesize_number_format = lambda value: formats.number_format(round(value, 1), 1)
+
     if bytes < 1024:
         return ungettext("%(size)d byte", "%(size)d bytes", bytes) % {'size': bytes}
     if bytes < 1024 * 1024:
-        return ugettext("%.1f KB") % (bytes / 1024)
+        return ugettext("%s KB") % filesize_number_format(bytes / 1024)
     if bytes < 1024 * 1024 * 1024:
-        return ugettext("%.1f MB") % (bytes / (1024 * 1024))
+        return ugettext("%s MB") % filesize_number_format(bytes / (1024 * 1024))
     if bytes < 1024 * 1024 * 1024 * 1024:
-        return ugettext("%.1f GB") % (bytes / (1024 * 1024 * 1024))
+        return ugettext("%s GB") % filesize_number_format(bytes / (1024 * 1024 * 1024))
     if bytes < 1024 * 1024 * 1024 * 1024 * 1024:
-        return ugettext("%.1f TB") % (bytes / (1024 * 1024 * 1024 * 1024))
-    return ugettext("%.1f PB") % (bytes / (1024 * 1024 * 1024 * 1024 * 1024))
+        return ugettext("%s TB") % filesize_number_format(bytes / (1024 * 1024 * 1024 * 1024))
+    return ugettext("%s PB") % filesize_number_format(bytes / (1024 * 1024 * 1024 * 1024 * 1024))
 filesizeformat.is_safe = True
 
 def pluralize(value, arg=u's'):
Index: tests/regressiontests/defaultfilters/tests.py
===================================================================
--- tests/regressiontests/defaultfilters/tests.py	(Revision 15148)
+++ tests/regressiontests/defaultfilters/tests.py	(Arbeitskopie)
@@ -443,6 +443,33 @@
         self.assertEqual(filesizeformat(u"\N{GREEK SMALL LETTER ALPHA}"),
                           u'0 bytes')
 
+    def test_localized_filesizeformat(self):
+        from django.utils.translation import activate, deactivate
+        old_localize = settings.USE_L10N
+        try:
+            activate('de')
+            settings.USE_L10N = True
+            self.assertEqual(filesizeformat(1023), u'1023 Bytes')
+            self.assertEqual(filesizeformat(1024), u'1,0 KB')
+            self.assertEqual(filesizeformat(10*1024), u'10,0 KB')
+            self.assertEqual(filesizeformat(1024*1024-1), u'1024,0 KB')
+            self.assertEqual(filesizeformat(1024*1024), u'1,0 MB')
+            self.assertEqual(filesizeformat(1024*1024*50), u'50,0 MB')
+            self.assertEqual(filesizeformat(1024*1024*1024-1), u'1024,0 MB')
+            self.assertEqual(filesizeformat(1024*1024*1024), u'1,0 GB')
+            self.assertEqual(filesizeformat(1024*1024*1024*1024), u'1,0 TB')
+            self.assertEqual(filesizeformat(1024*1024*1024*1024*1024),
+                              u'1,0 PB')
+            self.assertEqual(filesizeformat(1024*1024*1024*1024*1024*2000),
+                              u'2000,0 PB')
+            self.assertEqual(filesizeformat(complex(1,-1)), u'0 Bytes')
+            self.assertEqual(filesizeformat(""), u'0 Bytes')
+            self.assertEqual(filesizeformat(u"\N{GREEK SMALL LETTER ALPHA}"),
+                              u'0 Bytes')
+        finally:
+            deactivate()
+            settings.USE_L10N = old_localize
+
     def test_pluralize(self):
         self.assertEqual(pluralize(1), u'')
         self.assertEqual(pluralize(0), u's')
Index: AUTHORS
===================================================================
--- AUTHORS	(Revision 15148)
+++ AUTHORS	(Arbeitskopie)
@@ -129,7 +129,7 @@
     John D'Agostino <john.dagostino@gmail.com>
     dackze+django@gmail.com
     Mihai Damian <yang_damian@yahoo.com>
-    David Danier <goliath.mailinglist@gmx.de>
+    David Danier <david.danier@team23.de>
     Dirk Datzert <dummy@habmalnefrage.de>
     Jonathan Daugherty (cygnus) <http://www.cprogrammer.org/>
     dave@thebarproject.com